#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("gutest", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144]; // guコマンド格納用メモリ
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); // gu初期化
	sceGuStart(GU_DIRECT, list); // listにguコマンド格納を宣言
	sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH); // バッファのアドレス指定
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH); // 解像度/VRAMなど指定
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH); // Zバッファ用アドレス指定
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2)); // 仮想空間の中央を0,0にセット
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT); // ビューポートを仮想空間の2048,2048にセット
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT); // 切り抜き。今回は0,0なので全体表示。
	sceGuEnable(GU_SCISSOR_TEST); // 切り抜きを有効に。
	sceGuFinish(); // コマンド終了宣言
	sceGuSync(0,0); // コマンド同期(実行?)
	sceDisplayWaitVblankStart(); // 垂直同期待ち
	sceGuDisplay(GU_TRUE); // 画面描画有効
	// 描画テストループ
	while(1){
		// 背景塗りつぶし
		sceGuStart(GU_DIRECT,list); // 描画開始
		sceGuClearColor(0xFFFFFF00); // 背景色。aaBBGGRR。aa=透明度(FF=不透明)。
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);  // 背景色描画
		// 描画終了
		sceGuFinish();
		sceGuSync(0,0);
		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}
	return 0;
}
